kio Library: KIO::SlaveBase Class Reference (kio Library)

| # kio Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KIO::SlaveBase Class Reference

There are two classes that specifies the protocol between application (job) and kioslave. More...

`#include <slavebase.h>`

Inheritance diagram for KIO::SlaveBase:

[legend]
Collaboration diagram for KIO::SlaveBase:

[legend]
List of all members.

## Public Types
enum | MessageBoxType { QuestionYesNo = 1, WarningYesNo = 2, WarningContinueCancel = 3, WarningYesNoCancel = 4, Information = 5, SSLMessageBox = 6 }
## Public Member Functions
| SlaveBase (const QCString &protocol, const QCString &pool_socket, const QCString &app_socket)
void | exit ()
void | dispatchLoop ()
void | setConnection (Connection *connection)
Connection * | connection () const
void | data (const QByteArray &data)
void | dataReq ()
void | error (int _errid, const QString &_text)
void | connected ()
void | finished ()
void | needSubURLData ()
void | slaveStatus (const QString &host, bool connected)
void | statEntry (const UDSEntry &_entry)
void | listEntries (const UDSEntryList &_entry)
bool | canResume (KIO::filesize_t offset)
void | canResume ()
void | totalSize (KIO::filesize_t _bytes)
void | processedSize (KIO::filesize_t _bytes)
void | processedPercent (float percent)
void | speed (unsigned long _bytes_per_second)
void | redirection (const KURL &_url)
void | errorPage ()
void | mimeType (const QString &_type)
void | warning (const QString &msg)
void | infoMessage (const QString &msg)
int | messageBox (MessageBoxType type, const QString &text, const QString &caption=QString::null, const QString &buttonYes=QString::null, const QString &buttonNo=QString::null)
int | messageBox (const QString &text, MessageBoxType type, const QString &caption=QString::null, const QString &buttonYes=QString::null, const QString &buttonNo=QString::null, const QString &dontAskAgainName=QString::null)
void | setMetaData (const QString &key, const QString &value)
bool | hasMetaData (const QString &key) const
QString | metaData (const QString &key) const
bool | hasMetaData (const QString &key)
QString | metaData (const QString &key)
KConfigBase * | config ()
KRemoteEncoding * | remoteEncoding ()
virtual void | setHost (const QString &host, int port, const QString &user, const QString &pass)
virtual void | setSubURL (const KURL &url)
virtual void | openConnection ()
virtual void | closeConnection ()
virtual void | get (const KURL &url)
virtual void | put (const KURL &url, int permissions, bool overwrite, bool resume)
virtual void | stat (const KURL &url)
virtual void | mimetype (const KURL &url)
virtual void | listDir (const KURL &url)
virtual void | mkdir (const KURL &url, int permissions)
virtual void | rename (const KURL &src, const KURL &dest, bool overwrite)
virtual void | symlink (const QString &target, const KURL &dest, bool overwrite)
virtual void | chmod (const KURL &url, int permissions)
virtual void | copy (const KURL &src, const KURL &dest, int permissions, bool overwrite)
virtual void | del (const KURL &url, bool isfile)
virtual void | special (const QByteArray &data)
virtual void | multiGet (const QByteArray &data)
virtual void | slave_status ()
virtual void | reparseConfiguration ()
int | connectTimeout ()
int | proxyConnectTimeout ()
int | responseTimeout ()
int | readTimeout ()
void | setTimeoutSpecialCommand (int timeout, const QByteArray &data=QByteArray())
virtual bool | dispatch ()
virtual void | dispatch (int command, const QByteArray &data)
int | readData (QByteArray &buffer)
void | listEntry (const UDSEntry &_entry, bool ready)
void | connectSlave (const QString &path)
void | disconnectSlave ()
bool | openPassDlg (KIO::AuthInfo &info, const QString &errorMsg)
bool | openPassDlg (KIO::AuthInfo &info)
bool | checkCachedAuthentication (AuthInfo &info)
bool | cacheAuthentication (const AuthInfo &info)
bool | pingCacheDaemon () const
QString | createAuthCacheKey (const KURL &url)
void | sendAuthenticationKey (const QCString &gKey, const QCString &key, bool keep)
void | delCachedAuthentication (const QString &key)
void | setMultipleAuthCaching (bool)
bool | multipleAuthCaching () const
bool | requestNetwork (const QString &host=QString::null)
void | dropNetwork (const QString &host=QString::null)
DCOPClient * | dcopClient ()
int | waitForAnswer (int expected1, int expected2, QByteArray &data, int *pCmd=0)
void | sendMetaData ()
bool | wasKilled () const
void | setKillFlag ()
## Static Public Member Functions
static void | sigsegv_handler (int)
static void | sigpipe_handler (int)
## Public Attributes
QCString | mProtocol
Connection * | m_pConnection
MetaData | mOutgoingMetaData
MetaData | mIncomingMetaData
## Protected Member Functions
virtual void | virtual_hook (int id, void *data)
## Protected Attributes
UDSEntryList | pendingListEntries
uint | listEntryCurrentSize
long | listEntry_sec
long | listEntry_usec
Connection * | appconn
QString | mPoolSocket
QString | mAppSocket
bool | mConnectedToApp
## Static Protected Attributes
static long | s_seqNr

## Detailed Description

There are two classes that specifies the protocol between application (job) and kioslave.

SlaveInterface is the class to use on the application end, SlaveBase is the one to use on the slave end.

Slave implementations should simply inherit SlaveBase

A call to foo() results in a call to slotFoo() on the other end.

Definition at line 45 of file slavebase.h.

## Member Function Documentation

void SlaveBase::data | ( | const QByteArray & | data | ) |

  | Sends data in the slave to the job (i.e. in get). To signal end of data, simply send an empty QByteArray(). Parameters:
  | data | the data read by the slave
Definition at line 398 of file slavebase.cpp. References data(), QMap::isEmpty(), and sendMetaData(). Referenced by canResume(), data(), delCachedAuthentication(), dropNetwork(), error(), infoMessage(), listEntries(), messageBox(), mimeType(), processedSize(), redirection(), requestNetwork(), sendAuthenticationKey(), sendMetaData(), setTimeoutSpecialCommand(), slaveStatus(), speed(), statEntry(), totalSize(), waitForAnswer(), and warning().

void SlaveBase::dataReq | ( |  | ) |

| Asks for data from the job. See also: readData Definition at line 407 of file slavebase.cpp. References canResume().

void SlaveBase::error | ( | int | _errid,
|  | const QString & | _text
| ) |

  | Call to signal an error. This also finishes the job, no need to call finished. If the Error code is KIO::ERR_SLAVE_DEFINED then the _text should contain the complete translated text of of the error message. This message will be displayed in an KTextBrowser which allows rich text complete with hyper links. Email links will call the default mailer, "exec:/command arg1 arg2" will be forked and all other links will call the default browser. See also: KIO::Error KTextBrowser Parameters:
  | _errid | the error code from KIO::Error
  | _text | the rich text error message
Definition at line 418 of file slavebase.cpp. References QMap::clear(), and data(). Referenced by chmod(), copy(), del(), get(), listDir(), mkdir(), multiGet(), openConnection(), put(), rename(), setSubURL(), special(), stat(), and symlink().

void SlaveBase::connected | ( |  | ) |

| Call in openConnection, if you reimplement it, when you're done. Definition at line 431 of file slavebase.cpp.

void SlaveBase::finished | ( |  | ) |

| Call to signal successful completion of any command (besides openConnection and closeConnection). Definition at line 438 of file slavebase.cpp. References QMap::clear(), QMap::isEmpty(), and sendMetaData().

void SlaveBase::needSubURLData | ( |  | ) |

| Call to signal that data from the sub-URL is needed. Definition at line 451 of file slavebase.cpp.

void SlaveBase::slaveStatus | ( | const QString & | host,
|  | bool | connected
| ) |

  | Used to report the status of the slave. Parameters:
  | host | the slave is currently connected to. (Should be empty if not connected)
  | connected | Whether an actual network connection exists.
Definition at line 456 of file slavebase.cpp. References data(), and mProtocol. Referenced by slave_status().

void SlaveBase::statEntry | ( | const UDSEntry & | _entry | ) |

  | Call this from stat() to express details about an object, the UDSEntry customarily contains the atoms describing file name, size, mimetype, etc. Parameters:
  | _entry | The UDSEntry containing all of the object attributes.
Definition at line 636 of file slavebase.cpp. References data().

void SlaveBase::listEntries | ( | const UDSEntryList & | _entry | ) |

| Call this in listDir, each time you have a bunch of entries to report. Definition at line 686 of file slavebase.cpp. References QValueList::begin(), QValueList::count(), and data(). Referenced by listEntry().

bool SlaveBase::canResume | ( | KIO::filesize_t | offset | ) |

| Call this at the beginning of put(), to give the size of the existing partial file, if there is one. The `offset` argument notifies the other job (the one that gets the data) about the offset to use. In this case, the boolean returns whether we can indeed resume or not (we can't if the protocol doing the get() doesn't support setting an offset) Definition at line 888 of file slavebase.cpp. References data(), endl(), kdDebug(), KIO::number(), and waitForAnswer(). Referenced by dataReq().

void SlaveBase::totalSize | ( | KIO::filesize_t | _bytes | ) |

| Call this in get and copy, to give the total size of the file Call in listDir too, when you know the total number of items. Definition at line 471 of file slavebase.cpp. References data().

void SlaveBase::processedSize | ( | KIO::filesize_t | _bytes | ) |

| Call this during get and copy, once in a while, to give some info about the current state. Don't emit it in listDir, listEntries speaks for itself. Definition at line 487 of file slavebase.cpp. References data().

void SlaveBase::processedPercent | ( | float | percent | ) |

| Only use this if you can't know in advance the size of the copied data. For example, if you're doing variable bitrate compression of the source. STUB ! Currently unimplemented. Here now for binary compatibility. Call this during get and copy, once in a while, to give some info about the current state. Don't emit it in listDir, listEntries speaks for itself. Definition at line 523 of file slavebase.cpp. References endl(), and kdDebug().

void SlaveBase::speed | ( | unsigned long | _bytes_per_second | ) |

| Call this in get and copy, to give the current transfer speed, but only if it can't be calculated out of the size you passed to processedSize (in most cases you don't want to call it). Definition at line 529 of file slavebase.cpp. References data().

void SlaveBase::redirection | ( | const KURL & | _url | ) |

| Call this to signal a redirection The job will take care of going to that url. Definition at line 537 of file slavebase.cpp. References data().

void SlaveBase::errorPage | ( |  | ) |

| Tell that we will only get an error page here. This means: the data you'll get isn't the data you requested, but an error page (usually HTML) that describes an error. Definition at line 543 of file slavebase.cpp.

void SlaveBase::mimeType | ( | const QString & | _type | ) |

| Call this in mimetype() and in get(), when you know the mimetype. See mimetype about other ways to implement it. Definition at line 560 of file slavebase.cpp. References QMap::clear(), data(), endl(), QMap::isEmpty(), and kdDebug().

void SlaveBase::warning | ( | const QString & | msg | ) |

| Call to signal a warning, to be displayed in a dialog box. Definition at line 603 of file slavebase.cpp. References data().

void SlaveBase::infoMessage | ( | const QString & | msg | ) |

| Call to signal a message, to be displayed if the application wants to, for instance in a status bar. Usual examples are "connecting to host xyz", etc. Definition at line 609 of file slavebase.cpp. References data().

int SlaveBase::messageBox | ( | MessageBoxType | type,
|  | const QString & | text,
|  | const QString & | caption = `QString::null`,
|  | const QString & | buttonYes = `QString::null`,
|  | const QString & | buttonNo = `QString::null`
| ) |

  | Call this to show a message box from the slave. Parameters:
  | type | type of message box: QuestionYesNo, WarningYesNo, WarningContinueCancel...
  | text | Message string. May contain newlines.
  | caption | Message box title.
  | buttonYes | The text for the first button. The default is i18n("&Yes").
  | buttonNo | The text for the second button. The default is i18n("&No"). Note: for ContinueCancel, buttonYes is the continue button and buttonNo is unused. and for Information, none is used.
Returns: a button code, as defined in KMessageBox, or 0 on communication error. Definition at line 865 of file slavebase.cpp.

int SlaveBase::messageBox | ( | const QString & | text,
|  | MessageBoxType | type,
|  | const QString & | caption = `QString::null`,
|  | const QString & | buttonYes = `QString::null`,
|  | const QString & | buttonNo = `QString::null`,
|  | const QString & | dontAskAgainName = `QString::null`
| ) |

  | Call this to show a message box from the slave. Parameters:
  | text | Message string. May contain newlines.
  | type | type of message box: QuestionYesNo, WarningYesNo, WarningContinueCancel...
  | caption | Message box title.
  | buttonYes | The text for the first button. The default is i18n("&Yes").
  | buttonNo | The text for the second button. The default is i18n("&No"). Note: for ContinueCancel, buttonYes is the continue button and buttonNo is unused. and for Information, none is used.
  | dontAskAgainName | A checkbox is added with which further confirmation can be turned off. The string is used to lookup and store the setting in kioslaverc.
Returns: a button code, as defined in KMessageBox, or 0 on communication error. Since: 3.3 Definition at line 871 of file slavebase.cpp. References data(), endl(), kdDebug(), and waitForAnswer().

void SlaveBase::setMetaData | ( | const QString & | key,
|  | const QString & | value
| ) |

| Sets meta-data to be send to the application before the first data() or finished() signal. Definition at line 344 of file slavebase.cpp. References QMap::replace().

bool SlaveBase::hasMetaData | ( | const QString & | key | ) | const

| Queries for the existence of a certain config/meta-data entry send by the application to the slave. Since: 3.2 Definition at line 358 of file slavebase.cpp. References QMap::contains().

QString SlaveBase::metaData | ( | const QString & | key | ) | const

| Queries for config/meta-data send by the application to the slave. Since: 3.2 Definition at line 349 of file slavebase.cpp. References QMap::contains(). Referenced by cacheAuthentication(), checkCachedAuthentication(), connectTimeout(), openPassDlg(), proxyConnectTimeout(), readTimeout(), remoteEncoding(), and responseTimeout().

bool SlaveBase::hasMetaData | ( | const QString & | key | ) |

| Deprecated: kept for binary compatibility Queries for the existence of a certain config/meta-data entry send by the application to the slave. Definition at line 371 of file slavebase.cpp.

QString SlaveBase::metaData | ( | const QString & | key | ) |

| Deprecated: kept for binary compatibility Queries for config/meta-data send by the application to the slave. Definition at line 368 of file slavebase.cpp.

KConfigBase * SlaveBase::config | ( |  | ) |

| Returns a configuration object to query config/meta-data information from. The application provides the slave with all configuration information relevant for the current protocol and host. Definition at line 375 of file slavebase.cpp.

KRemoteEncoding * SlaveBase::remoteEncoding | ( |  | ) |

| Returns an object that can translate remote filenames into proper Unicode forms. This encoding can be set by the user. Since: 3.3 Definition at line 390 of file slavebase.cpp. References metaData().

void SlaveBase::setHost | ( | const QString & | host,
|  | int | port,
|  | const QString & | user,
|  | const QString & | pass
| ) | `[virtual]`

  | Set the host. Parameters:
  | host |
  | port |
  | user |
  | pass | Called directly by createSlave, this is why there is no equivalent in SlaveInterface, unlike the other methods.
This method is called whenever a change in host, port or user occurs. Definition at line 750 of file slavebase.cpp.

void SlaveBase::setSubURL | ( | const KURL & | url | ) | `[virtual]`

| Prepare slave for streaming operation. Definition at line 782 of file slavebase.cpp. References error(), mProtocol, and KIO::unsupportedActionErrorString().

void SlaveBase::openConnection | ( |  | ) | `[virtual]`

| Opens the connection (forced) When this function gets called the slave is operating in connection-oriented mode. When a connection gets lost while the slave operates in connection oriented mode, the slave should report ERR_CONNECTION_BROKEN instead of reconnecting. The user is expected to disconnect the slave in the error handler. Definition at line 754 of file slavebase.cpp. References error(), mProtocol, and KIO::unsupportedActionErrorString().

void SlaveBase::closeConnection | ( |  | ) | `[virtual]`

| Closes the connection (forced) Called when the application disconnects the slave to close any open network connections. When the slave was operating in connection-oriented mode, it should reset itself to connectionless (default) mode. Definition at line 756 of file slavebase.cpp.

void SlaveBase::get | ( | const KURL & | url | ) | `[virtual]`

  | get, aka read. Parameters:
  | url | the full url for this request. Host, port and user of the URL can be assumed to be the same as in the last setHost() call. The slave emits the data through data
Reimplemented in KIO::ForwardingSlaveBase. Definition at line 766 of file slavebase.cpp. References error(), mProtocol, and KIO::unsupportedActionErrorString(). Referenced by mimetype().

void SlaveBase::put | ( | const KURL & | url,
|  | int | permissions,
|  | bool | overwrite,
|  | bool | resume
| ) | `[virtual]`

  | put, aka write. Parameters:
  | url | where to write the file (decoded)
  | permissions | may be -1. In this case no special permission mode is set.
  | overwrite | if true, any existing file will be overwritten. If the file indeed already exists, the slave should NOT apply the permissions change to it.
  | resume |
Reimplemented in KIO::ForwardingSlaveBase. Definition at line 760 of file slavebase.cpp. References error(), mProtocol, and KIO::unsupportedActionErrorString().

void SlaveBase::stat | ( | const KURL & | url | ) | `[virtual]`

| Finds all details for one file or directory. The information returned is the same as what listDir returns, but only for one file or directory. Reimplemented in KIO::ForwardingSlaveBase. Definition at line 758 of file slavebase.cpp. References error(), mProtocol, and KIO::unsupportedActionErrorString().

void SlaveBase::mimetype | ( | const KURL & | url | ) | `[virtual]`

| Finds mimetype for one file or directory. This method should either emit 'mimeType' or it should send a block of data big enough to be able to determine the mimetype. If the slave doesn't reimplement it, a get will be issued, i.e. the whole file will be downloaded before determining the mimetype on it - this is obviously not a good thing in most cases. Reimplemented in KIO::ForwardingSlaveBase. Definition at line 768 of file slavebase.cpp. References get().

void SlaveBase::listDir | ( | const KURL & | url | ) | `[virtual]`

| Lists the contents of `url`. The slave should emit ERR_CANNOT_ENTER_DIRECTORY if it doesn't exist, if we don't have enough permissions, or if it is a file It should also emit totalFiles as soon as it knows how many files it will list. Reimplemented in KIO::ForwardingSlaveBase. Definition at line 764 of file slavebase.cpp. References error(), mProtocol, and KIO::unsupportedActionErrorString().

void SlaveBase::mkdir | ( | const KURL & | url,
|  | int | permissions
| ) | `[virtual]`

  | Create a directory. Parameters:
  | url | path to the directory to create
  | permissions | the permissions to set after creating the directory (-1 if no permissions to be set) The slave emits ERR_COULD_NOT_MKDIR if failure.
Reimplemented in KIO::ForwardingSlaveBase. Definition at line 778 of file slavebase.cpp. References error(), mProtocol, and KIO::unsupportedActionErrorString().

void SlaveBase::rename | ( | const KURL & | src,
|  | const KURL & | dest,
|  | bool | overwrite
| ) | `[virtual]`

  | Rename `oldname` into `newname`. If the slave returns an error ERR_UNSUPPORTED_ACTION, the job will ask for copy + del instead. Parameters:
  | src | where to move the file from
  | dest | where to move the file to
  | overwrite | if true, any existing file will be overwritten
Reimplemented in KIO::ForwardingSlaveBase. Definition at line 770 of file slavebase.cpp. References error(), mProtocol, and KIO::unsupportedActionErrorString().

void SlaveBase::symlink | ( | const QString & | target,
|  | const KURL & | dest,
|  | bool | overwrite
| ) | `[virtual]`

  | Creates a symbolic link named `dest`, pointing to `target`, which may be a relative or an absolute path. Parameters:
  | target | The string that will become the "target" of the link (can be relative)
  | dest | The symlink to create.
  | overwrite | whether to automatically overwrite if the dest exists
Reimplemented in KIO::ForwardingSlaveBase. Definition at line 772 of file slavebase.cpp. References error(), mProtocol, and KIO::unsupportedActionErrorString().

void SlaveBase::chmod | ( | const KURL & | url,
|  | int | permissions
| ) | `[virtual]`

| Change permissions on `path` The slave emits ERR_DOES_NOT_EXIST or ERR_CANNOT_CHMOD. Reimplemented in KIO::ForwardingSlaveBase. Definition at line 780 of file slavebase.cpp. References error(), mProtocol, and KIO::unsupportedActionErrorString().

void SlaveBase::copy | ( | const KURL & | src,
|  | const KURL & | dest,
|  | int | permissions,
|  | bool | overwrite
| ) | `[virtual]`

  | Copy `src` into `dest`. If the slave returns an error ERR_UNSUPPORTED_ACTION, the job will ask for get + put instead. Parameters:
  | src | where to copy the file from (decoded)
  | dest | where to copy the file to (decoded)
  | permissions | may be -1. In this case no special permission mode is set.
  | overwrite | if true, any existing file will be overwritten
Reimplemented in KIO::ForwardingSlaveBase. Definition at line 774 of file slavebase.cpp. References error(), mProtocol, and KIO::unsupportedActionErrorString().

void SlaveBase::del | ( | const KURL & | url,
|  | bool | isfile
| ) | `[virtual]`

  | Delete a file or directory. Parameters:
  | url | file/directory to delete
  | isfile | if true, a file should be deleted. if false, a directory should be deleted.
Reimplemented in KIO::ForwardingSlaveBase. Definition at line 776 of file slavebase.cpp. References error(), mProtocol, and KIO::unsupportedActionErrorString().

void SlaveBase::special | ( | const QByteArray & | data | ) | `[virtual]`

  | Used for any command that is specific to this slave (protocol) Examples are : HTTP POST, mount and unmount (kio_file). Parameters:
  | data | packed data; the meaning is completely dependent on the slave, but usually starts with an int for the command number. Document your slave's commands, at least in its header file.
Definition at line 762 of file slavebase.cpp. References error(), mProtocol, and KIO::unsupportedActionErrorString().

void SlaveBase::multiGet | ( | const QByteArray & | data | ) | `[virtual]`

  | Used for multiple get. Currently only used foir HTTP pielining support. Parameters:
  | data | packed data; Contains number of URLs to fetch, and for each URL the URL itself and its associated MetaData.
Definition at line 784 of file slavebase.cpp. References error(), mProtocol, and KIO::unsupportedActionErrorString().

void SlaveBase::slave_status | ( |  | ) | `[virtual]`

| Called to get the status of the slave. Slave should respond by calling slaveStatus(...) Definition at line 788 of file slavebase.cpp. References slaveStatus().

void SlaveBase::reparseConfiguration | ( |  | ) | `[virtual]`

| Called by the scheduler to tell the slave that the configuration changed (i.e. proxy settings) . Definition at line 791 of file slavebase.cpp.

int SlaveBase::connectTimeout | ( |  | ) |

| Returns: timeout value for connecting to remote host. Definition at line 1210 of file slavebase.cpp. References metaData(), and QString::toInt().

int SlaveBase::proxyConnectTimeout | ( |  | ) |

| Returns: timeout value for connecting to proxy in secs. Definition at line 1220 of file slavebase.cpp. References metaData(), and QString::toInt().

int SlaveBase::responseTimeout | ( |  | ) |

| Returns: timeout value for read from first data from remote host in seconds. Definition at line 1231 of file slavebase.cpp. References metaData(), and QString::toInt().

int SlaveBase::readTimeout | ( |  | ) |

| Returns: timeout value for read from subsequent data from remote host in secs. Definition at line 1242 of file slavebase.cpp. References metaData(), and QString::toInt().

void SlaveBase::setTimeoutSpecialCommand | ( | int | timeout,
|  | const QByteArray & | data = `QByteArray()`
| ) |

| This function sets a timeout of `timeout` seconds and calls special(data) when the timeout occurs as if it was called by the application. A timeout can only occur when the slave is waiting for a command from the application. Specifying a negative timeout cancels a pending timeout. Only one timeout at a time is supported, setting a timeout cancels any pending timeout. Since: 3.1 Definition at line 945 of file slavebase.cpp. References data().

int SlaveBase::readData | ( | QByteArray & | buffer | ) |

  | Read data send by the job, after a dataReq. Parameters:
  | buffer | buffer where data is stored
Returns: 0 on end of data, > 0 bytes read < 0 error Definition at line 938 of file slavebase.cpp. References waitForAnswer().

void SlaveBase::listEntry | ( | const UDSEntry & | _entry,
|  | bool | ready
| ) |

  | internal function to be called by the slave. It collects entries and emits them via listEntries when enough of them are there or a certain time frame exceeded (to make sure the app gets some items in time but not too many items one by one as this will cause a drastic performance penalty) Parameters:
  | ready | set to true after emitting all items. _entry is not used in this case
Definition at line 644 of file slavebase.cpp. References QValueList::append(), QValueList::clear(), QValueList::count(), and listEntries().

void SlaveBase::connectSlave | ( | const QString & | path | ) |

| internal function to connect a slave to/ disconnect from either the slave pool or the application Definition at line 325 of file slavebase.cpp. References endl(), KIO::Connection::init(), KIO::Connection::inited(), and kdDebug().

bool SlaveBase::openPassDlg | ( | KIO::AuthInfo & | info,
|  | const QString & | errorMsg
| ) |

| Prompt the user for Authorization info (login & password). Use this function to request authorization information from the end user. You can also pass an error message which explains why a previous authorization attempt failed. Here is a very simple example:
     KIO::AuthInfo authInfo;
     if ( openPassDlg( authInfo ) )
     {
        kdDebug() << QString::fromLatin1("User: ")
                  << authInfo.username << endl;
        kdDebug() << QString::fromLatin1("Password: ")
                  << QString::fromLatin1("Not displayed here!") << endl;
     }
You can also preset some values like the username, caption or comment as follows:
     KIO::AuthInfo authInfo;
     authInfo.caption= "Acme Password Dialog";
     authInfo.username= "Wile E. Coyote";
     QString errorMsg = "You entered an incorrect password.";
     if ( openPassDlg( authInfo, errorMsg ) )
     {
        kdDebug() << QString::fromLatin1("User: ")
                  << authInfo.username << endl;
        kdDebug() << QString::fromLatin1("Password: ")
                  << QString::fromLatin1("Not displayed here!") << endl;
     }
  Note: You should consider using checkCachedAuthentication() to see if the password is available in kpasswdserver before calling this function. A call to this function can fail and return `false`, if the UIServer could not be started for whatever reason. See also: checkCachedAuthentication Parameters:
  | info | See AuthInfo.
  | errorMsg | Error message to show
Returns: `true` if user clicks on "OK", `false` otherwsie. Since: 3.1 Definition at line 816 of file slavebase.cpp. References dcopClient(), endl(), KIO::AuthInfo::isModified(), kdDebug(), kdError(), kdWarning(), metaData(), and QString::toLong(). Referenced by openPassDlg().

bool SlaveBase::openPassDlg | ( | KIO::AuthInfo & | info | ) |

| Same as above function except it does not need error message. BIC: Combine this function with the above for KDE4. Definition at line 811 of file slavebase.cpp. References openPassDlg().

bool SlaveBase::checkCachedAuthentication | ( | AuthInfo & | info | ) |

| Checks for cached authentication based on parameters given by `info`. Use this function to check if any cached password exists for the URL given by `info`. If `AuthInfo::realmValue` and/or `AuthInfo::verifyPath` flag is specified, then they will also be factored in determining the presence of a cached password. Note that `Auth::url` is a required parameter when attempting to check for cached authorization info. Here is a simple example:
     AuthInfo info;
     info.url = KURL("http://www.foobar.org/foo/bar");
     info.username = "somename";
     info.verifyPath = true;
     if ( !checkCachedAuthentication( info ) )
     {
        if ( !openPassDlg(info) )
         ....
     }
  Parameters:
  | info | See AuthInfo.
Returns: `true` if cached Authorization is found, false otherwise. Definition at line 1153 of file slavebase.cpp. References dcopClient(), endl(), KIO::AuthInfo::isModified(), kdDebug(), kdError(), kdWarning(), metaData(), and QString::toLong().

bool SlaveBase::cacheAuthentication | ( | const AuthInfo & | info | ) |

| Explicitly store authentication information. openPassDlg already stores password information automatically, you only need to call this function if you want to store authentication information that is different from the information returned by openPassDlg. Definition at line 1195 of file slavebase.cpp. References dcopClient(), metaData(), and QString::toLong().

bool SlaveBase::pingCacheDaemon | ( |  | ) | const

| Deprecated: as of 3.1. TODO: Remove before KDE 4.0 Definition at line 1131 of file slavebase.cpp. References endl(), and kdDebug().

QString SlaveBase::createAuthCacheKey | ( | const KURL & | url | ) |

  | Deprecated: as of 3.1. Use openPassDlg instead. TODO: Remove before KDE 4.0 Creates a basic key to be used to cache the password. Parameters:
  | url | the url from which the key is supposed to be generated
Definition at line 1112 of file slavebase.cpp. References QString::number().

void SlaveBase::sendAuthenticationKey | ( | const QCString & | gKey,
|  | const QCString & | key,
|  | bool | keep
| ) |

| Deprecated: as of 3.1. Use openPassDlg instead. TODO: Remove before KDE 4.0 Cache authentication information is now stored automatically by openPassDlg. Definition at line 699 of file slavebase.cpp. References data().

void SlaveBase::delCachedAuthentication | ( | const QString & | key | ) |

| Deprecated: as of 3.1. Use openPassDlg instead. TODO: Remove before KDE 4.0 Cached authentication information is now session based and removed automatically when a given session ends, i.e. the application is closed. Definition at line 707 of file slavebase.cpp. References data().

void KIO::SlaveBase::setMultipleAuthCaching | ( | bool |  | ) | `[inline]`

| Deprecated: as of 3.1. Use openPassDlg instead. TODO: Remove before KDE 4.0 Definition at line 725 of file slavebase.h.

bool KIO::SlaveBase::multipleAuthCaching | ( |  | ) | const`[inline]`

| Deprecated: as of 3.1. Use openPassDlg instead. TODO: Remove before KDE 4.0 Definition at line 731 of file slavebase.h.

bool SlaveBase::requestNetwork | ( | const QString & | host = `QString::null` | ) |

  | Used by the slave to check if it can connect to a given host. This should be called where the slave is ready to do a ::connect() on a socket. For each call to requestNetwork must exist a matching call to dropNetwork, or the system will stay online until KNetMgr gets closed (or the SlaveBase gets destructed)! If KNetMgr is not running, then this is a no-op and returns true Parameters:
  | host | tells the netmgr the host the slave wants to connect to. As this could also be a proxy, we can't just take the host currenctly connected to (but that's the default value)
Returns: true in theorie, the host is reachable false the system is offline and the host is in a remote network. Definition at line 615 of file slavebase.cpp. References data(), and waitForAnswer().

void SlaveBase::dropNetwork | ( | const QString & | host = `QString::null` | ) |

  | Used by the slave to withdraw a connection requested by requestNetwork. This function cancels the last call to requestNetwork. If a client uses more than one internet connection, it must use dropNetwork(host) to stop each request. If KNetMgr is not running, then this is a no-op. Parameters:
  | host | the host passed to requestNetwork
A slave should call this function every time it disconnect from a host. Definition at line 630 of file slavebase.cpp. References data().

DCOPClient * SlaveBase::dcopClient | ( |  | ) |

| Return the dcop client used by this slave. Since: 3.1 Definition at line 242 of file slavebase.cpp. References DCOPClient::attach(), and KApplication::dcopClient(). Referenced by cacheAuthentication(), checkCachedAuthentication(), and openPassDlg().

int SlaveBase::waitForAnswer | ( | int | expected1,
|  | int | expected2,
|  | QByteArray & | data,
|  | int * | pCmd = `0`
| ) |

| Wait for an answer to our request, until we get `expected1` or `expected2`. Returns: the result from readData, as well as the cmd in *pCmd if set, and the data in `data` Definition at line 910 of file slavebase.cpp. References data(), endl(), kdDebug(), and kdWarning(). Referenced by canResume(), messageBox(), readData(), and requestNetwork().

void SlaveBase::sendMetaData | ( |  | ) |

| Internal function to transmit meta data to the application. Definition at line 380 of file slavebase.cpp. References QMap::clear(), and data(). Referenced by data(), and finished().

bool SlaveBase::wasKilled | ( |  | ) | const

| If your ioslave was killed by a signal, wasKilled() returns true. Check it regularly in lengthy functions (e.g. in get();) and return as fast as possible from this function if wasKilled() returns true. This will ensure that your slave destructor will be called correctly. Since: 3.1 Definition at line 1252 of file slavebase.cpp.

void SlaveBase::setKillFlag | ( |  | ) |

| Internally used. Definition at line 1257 of file slavebase.cpp.

## Member Data Documentation

QCString KIO::SlaveBase::mProtocol

| Name of the protocol supported by this slave. Definition at line 788 of file slavebase.h. Referenced by chmod(), copy(), del(), get(), listDir(), mkdir(), multiGet(), openConnection(), put(), rename(), setSubURL(), slaveStatus(), special(), stat(), and symlink().

The documentation for this class was generated from the following files:

- slavebase.h
- slavebase.cpp

This file is part of the documentation for kio Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:27:11 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003